package dev.shadowsoffire.apotheosis.village.fletching.arrows;

import net.minecraft.world.effect.MobEffectInstance;
import dev.shadowsoffire.attributeslib.api.ALObjects;
import net.minecraft.world.effect.MobEffect;
import net.minecraft.world.entity.Entity;
import net.minecraftforge.network.NetworkHooks;
import net.minecraft.network.protocol.game.ClientGamePacketListener;
import net.minecraft.network.protocol.Packet;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.LivingEntity;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.projectile.Arrow;

public class BroadheadArrowEntity extends Arrow
{
    public BroadheadArrowEntity(final EntityType<? extends Arrow> t, final Level world) {
        super((EntityType)t, world);
    }
    
    public BroadheadArrowEntity(final Level world) {
        super((EntityType)Apoth.Entities.BROADHEAD_ARROW.get(), world);
    }
    
    public BroadheadArrowEntity(final LivingEntity shooter, final Level world) {
        super(world, shooter);
    }
    
    public BroadheadArrowEntity(final Level world, final double x, final double y, final double z) {
        super(world, x, y, z);
    }
    
    protected ItemStack m_7941_() {
        return new ItemStack((ItemLike)Apoth.Items.BROADHEAD_ARROW.get());
    }
    
    public Packet<ClientGamePacketListener> m_5654_() {
        return (Packet<ClientGamePacketListener>)NetworkHooks.getEntitySpawningPacket((Entity)this);
    }
    
    public EntityType<?> m_6095_() {
        return (EntityType<?>)Apoth.Entities.BROADHEAD_ARROW.get();
    }
    
    public int m_36889_() {
        return -1;
    }
    
    protected void m_7761_(final LivingEntity living) {
        final MobEffect bleeding = (MobEffect)ALObjects.MobEffects.BLEEDING.get();
        final MobEffectInstance bleed = living.m_21124_(bleeding);
        if (bleed != null) {
            living.m_7292_(new MobEffectInstance(bleeding, bleed.m_19557_() + 60, bleed.m_19564_() + 1));
        }
        else {
            living.m_7292_(new MobEffectInstance(bleeding, 300));
        }
    }
    
    public BroadheadArrowEntity bleed() {
        this.m_36870_(new MobEffectInstance((MobEffect)ALObjects.MobEffects.BLEEDING.get(), 300));
        return this;
    }
}
